/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// aLegCallId - The unique ID of the A sip leg.    bLegCallId - The unique ID of the B sip leg.    relayDtmf - True if the bridge relays DTMF as well.
    /// </summary>
    [DataContract]
        public partial class BridgeCreateParams :  IEquatable<BridgeCreateParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BridgeCreateParams" /> class.
        /// </summary>
        /// <param name="aLeg">aLeg.</param>
        /// <param name="bLeg">bLeg.</param>
        /// <param name="relayDtmf">relayDtmf.</param>
        public BridgeCreateParams(string aLeg = default(string), string bLeg = default(string), bool? relayDtmf = default(bool?))
        {
            this.ALeg = aLeg;
            this.BLeg = bLeg;
            this.RelayDtmf = relayDtmf;
        }
        
        /// <summary>
        /// Gets or Sets ALeg
        /// </summary>
        [DataMember(Name="aLeg", EmitDefaultValue=false)]
        public string ALeg { get; set; }

        /// <summary>
        /// Gets or Sets BLeg
        /// </summary>
        [DataMember(Name="bLeg", EmitDefaultValue=false)]
        public string BLeg { get; set; }

        /// <summary>
        /// Gets or Sets RelayDtmf
        /// </summary>
        [DataMember(Name="relayDtmf", EmitDefaultValue=false)]
        public bool? RelayDtmf { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BridgeCreateParams {\n");
            sb.Append("  ALeg: ").Append(ALeg).Append("\n");
            sb.Append("  BLeg: ").Append(BLeg).Append("\n");
            sb.Append("  RelayDtmf: ").Append(RelayDtmf).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BridgeCreateParams);
        }

        /// <summary>
        /// Returns true if BridgeCreateParams instances are equal
        /// </summary>
        /// <param name="input">Instance of BridgeCreateParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BridgeCreateParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ALeg == input.ALeg ||
                    (this.ALeg != null &&
                    this.ALeg.Equals(input.ALeg))
                ) && 
                (
                    this.BLeg == input.BLeg ||
                    (this.BLeg != null &&
                    this.BLeg.Equals(input.BLeg))
                ) && 
                (
                    this.RelayDtmf == input.RelayDtmf ||
                    (this.RelayDtmf != null &&
                    this.RelayDtmf.Equals(input.RelayDtmf))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ALeg != null)
                    hashCode = hashCode * 59 + this.ALeg.GetHashCode();
                if (this.BLeg != null)
                    hashCode = hashCode * 59 + this.BLeg.GetHashCode();
                if (this.RelayDtmf != null)
                    hashCode = hashCode * 59 + this.RelayDtmf.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
